//----------MV.c lib3D_MEC expoted-----------

//For increased velocity use GSL HAVE_INLINE and GSL_RANGE_CHECK_OFF preprocesor directive to compile:

// gcc -DHAVE_INLINE = 1 -DGSL_RANGE_CHECK_OFF = 1 ... ---

#include <stdio.h>
#include <gsl/gsl_matrix.h>
#include "var_def.h"
#include "gen_coord_vect_def.h"
#include "gen_vel_vect_def.h"
#include "gen_accel_vect_def.h"
#include "unknowns_vect_def.h"
#include <math.h>
#define x gsl_vector_get ( q , 0 )
#define theta gsl_vector_get ( q , 1 )
#define dx gsl_vector_get ( dq , 0 )
#define dtheta gsl_vector_get ( dq , 1 )
#define ddx gsl_vector_get ( ddq , 0 )
#define ddtheta gsl_vector_get ( ddq , 1 )
#define Fgby gsl_vector_get ( unknowns , 0 )
#define Fgbz gsl_vector_get ( unknowns , 1 )
#define Mgbx gsl_vector_get ( unknowns , 2 )
#define Mgby gsl_vector_get ( unknowns , 3 )
#define Mgbz gsl_vector_get ( unknowns , 4 )
#define Fbpx gsl_vector_get ( unknowns , 5 )
#define Fbpy gsl_vector_get ( unknowns , 6 )
#define Fbpz gsl_vector_get ( unknowns , 7 )
#define Mbpx gsl_vector_get ( unknowns , 8 )
#define Mbpz gsl_vector_get ( unknowns , 9 )
extern double atom43;
extern double atom44;
extern double atom2;
extern double atom6;
extern double atom4;
extern double atom5;
gsl_matrix * J = NULL;
gsl_matrix * MV ()
{
size_t n_rows = 12;
size_t n_cols = 12;
if ( J == NULL )
 {
    J = gsl_matrix_alloc ( n_rows , n_cols );
    gsl_matrix_set_zero ( J );
gsl_matrix_set ( J , 0 , 0 , -mblock );
gsl_matrix_set ( J , 0 , 1 , 0.0 );
gsl_matrix_set ( J , 0 , 2 , 0.0 );
gsl_matrix_set ( J , 0 , 3 , 0.0 );
gsl_matrix_set ( J , 0 , 4 , 0.0 );
gsl_matrix_set ( J , 0 , 5 , 0.0 );
gsl_matrix_set ( J , 0 , 6 , 0.0 );
gsl_matrix_set ( J , 0 , 7 , -1.0 );
gsl_matrix_set ( J , 0 , 8 , 0.0 );
gsl_matrix_set ( J , 0 , 9 , 0.0 );
gsl_matrix_set ( J , 0 , 10 , 0.0 );
gsl_matrix_set ( J , 0 , 11 , 0.0 );
gsl_matrix_set ( J , 1 , 0 , 0.0 );
gsl_matrix_set ( J , 1 , 1 , 0.0 );
gsl_matrix_set ( J , 1 , 2 , 1.0 );
gsl_matrix_set ( J , 1 , 3 , 0.0 );
gsl_matrix_set ( J , 1 , 4 , 0.0 );
gsl_matrix_set ( J , 1 , 5 , 0.0 );
gsl_matrix_set ( J , 1 , 6 , 0.0 );
gsl_matrix_set ( J , 1 , 7 , 0.0 );
gsl_matrix_set ( J , 1 , 8 , -1.0 );
gsl_matrix_set ( J , 1 , 9 , 0.0 );
gsl_matrix_set ( J , 1 , 10 , 0.0 );
gsl_matrix_set ( J , 1 , 11 , 0.0 );
gsl_matrix_set ( J , 2 , 0 , 0.0 );
gsl_matrix_set ( J , 2 , 1 , 0.0 );
gsl_matrix_set ( J , 2 , 2 , 0.0 );
gsl_matrix_set ( J , 2 , 3 , 1.0 );
gsl_matrix_set ( J , 2 , 4 , 0.0 );
gsl_matrix_set ( J , 2 , 5 , 0.0 );
gsl_matrix_set ( J , 2 , 6 , 0.0 );
gsl_matrix_set ( J , 2 , 7 , 0.0 );
gsl_matrix_set ( J , 2 , 8 , 0.0 );
gsl_matrix_set ( J , 2 , 9 , -1.0 );
gsl_matrix_set ( J , 2 , 10 , 0.0 );
gsl_matrix_set ( J , 2 , 11 , 0.0 );
gsl_matrix_set ( J , 3 , 0 , 0.0 );
gsl_matrix_set ( J , 3 , 1 , 0.0 );
gsl_matrix_set ( J , 3 , 2 , (1.0/2.0)*d );
gsl_matrix_set ( J , 3 , 3 , 0.0 );
gsl_matrix_set ( J , 3 , 4 , 1.0 );
gsl_matrix_set ( J , 3 , 5 , 0.0 );
gsl_matrix_set ( J , 3 , 6 , 0.0 );
gsl_matrix_set ( J , 3 , 7 , 0.0 );
gsl_matrix_set ( J , 3 , 8 , 0.0 );
gsl_matrix_set ( J , 3 , 9 , 0.0 );
gsl_matrix_set ( J , 3 , 10 , -1.0 );
gsl_matrix_set ( J , 3 , 11 , 0.0 );
gsl_matrix_set ( J , 4 , 0 , 0.0 );
gsl_matrix_set ( J , 4 , 1 , 0.0 );
gsl_matrix_set ( J , 4 , 2 , 0.0 );
gsl_matrix_set ( J , 4 , 3 , 0.0 );
gsl_matrix_set ( J , 4 , 4 , 0.0 );
gsl_matrix_set ( J , 4 , 5 , 1.0 );
gsl_matrix_set ( J , 4 , 6 , 0.0 );
gsl_matrix_set ( J , 4 , 7 , 0.0 );
gsl_matrix_set ( J , 4 , 8 , 0.0 );
gsl_matrix_set ( J , 4 , 9 , 0.0 );
gsl_matrix_set ( J , 4 , 10 , 0.0 );
gsl_matrix_set ( J , 4 , 11 , 0.0 );
gsl_matrix_set ( J , 5 , 0 , 0.0 );
gsl_matrix_set ( J , 5 , 1 , 0.0 );
gsl_matrix_set ( J , 5 , 2 , 0.0 );
gsl_matrix_set ( J , 5 , 3 , 0.0 );
gsl_matrix_set ( J , 5 , 4 , 0.0 );
gsl_matrix_set ( J , 5 , 5 , 0.0 );
gsl_matrix_set ( J , 5 , 6 , 1.0 );
gsl_matrix_set ( J , 5 , 7 , 0.0 );
gsl_matrix_set ( J , 5 , 8 , 0.0 );
gsl_matrix_set ( J , 5 , 9 , 0.0 );
gsl_matrix_set ( J , 5 , 10 , 0.0 );
gsl_matrix_set ( J , 5 , 11 , -1.0 );
gsl_matrix_set ( J , 6 , 0 , -mpendulum );
gsl_matrix_set ( J , 6 , 2 , 0.0 );
gsl_matrix_set ( J , 6 , 3 , 0.0 );
gsl_matrix_set ( J , 6 , 4 , 0.0 );
gsl_matrix_set ( J , 6 , 5 , 0.0 );
gsl_matrix_set ( J , 6 , 6 , 0.0 );
gsl_matrix_set ( J , 6 , 7 , 1.0 );
gsl_matrix_set ( J , 6 , 8 , 0.0 );
gsl_matrix_set ( J , 6 , 9 , 0.0 );
gsl_matrix_set ( J , 6 , 10 , 0.0 );
gsl_matrix_set ( J , 6 , 11 , 0.0 );
gsl_matrix_set ( J , 7 , 0 , 0.0 );
gsl_matrix_set ( J , 7 , 1 , 0.0 );
gsl_matrix_set ( J , 7 , 2 , 0.0 );
gsl_matrix_set ( J , 7 , 3 , 0.0 );
gsl_matrix_set ( J , 7 , 4 , 0.0 );
gsl_matrix_set ( J , 7 , 5 , 0.0 );
gsl_matrix_set ( J , 7 , 6 , 0.0 );
gsl_matrix_set ( J , 7 , 7 , 0.0 );
gsl_matrix_set ( J , 7 , 8 , 1.0 );
gsl_matrix_set ( J , 7 , 9 , 0.0 );
gsl_matrix_set ( J , 7 , 10 , 0.0 );
gsl_matrix_set ( J , 7 , 11 , 0.0 );
gsl_matrix_set ( J , 8 , 0 , 0.0 );
gsl_matrix_set ( J , 8 , 2 , 0.0 );
gsl_matrix_set ( J , 8 , 3 , 0.0 );
gsl_matrix_set ( J , 8 , 4 , 0.0 );
gsl_matrix_set ( J , 8 , 5 , 0.0 );
gsl_matrix_set ( J , 8 , 6 , 0.0 );
gsl_matrix_set ( J , 8 , 7 , 0.0 );
gsl_matrix_set ( J , 8 , 8 , 0.0 );
gsl_matrix_set ( J , 8 , 9 , 1.0 );
gsl_matrix_set ( J , 8 , 10 , 0.0 );
gsl_matrix_set ( J , 8 , 11 , 0.0 );
gsl_matrix_set ( J , 9 , 0 , 0.0 );
gsl_matrix_set ( J , 9 , 1 , 0.0 );
gsl_matrix_set ( J , 9 , 2 , 0.0 );
gsl_matrix_set ( J , 9 , 3 , 0.0 );
gsl_matrix_set ( J , 9 , 4 , 0.0 );
gsl_matrix_set ( J , 9 , 5 , 0.0 );
gsl_matrix_set ( J , 9 , 6 , 0.0 );
gsl_matrix_set ( J , 9 , 7 , 0.0 );
gsl_matrix_set ( J , 9 , 9 , 0.0 );
gsl_matrix_set ( J , 9 , 10 , 1.0 );
gsl_matrix_set ( J , 9 , 11 , 0.0 );
gsl_matrix_set ( J , 10 , 0 , 0.0 );
gsl_matrix_set ( J , 10 , 1 , I2 );
gsl_matrix_set ( J , 10 , 2 , 0.0 );
gsl_matrix_set ( J , 10 , 3 , 0.0 );
gsl_matrix_set ( J , 10 , 4 , 0.0 );
gsl_matrix_set ( J , 10 , 5 , 0.0 );
gsl_matrix_set ( J , 10 , 6 , 0.0 );
gsl_matrix_set ( J , 10 , 8 , 0.0 );
gsl_matrix_set ( J , 10 , 10 , 0.0 );
gsl_matrix_set ( J , 10 , 11 , 0.0 );
gsl_matrix_set ( J , 11 , 0 , 0.0 );
gsl_matrix_set ( J , 11 , 1 , 0.0 );
gsl_matrix_set ( J , 11 , 2 , 0.0 );
gsl_matrix_set ( J , 11 , 3 , 0.0 );
gsl_matrix_set ( J , 11 , 4 , 0.0 );
gsl_matrix_set ( J , 11 , 5 , 0.0 );
gsl_matrix_set ( J , 11 , 6 , 0.0 );
gsl_matrix_set ( J , 11 , 7 , 0.0 );
gsl_matrix_set ( J , 11 , 9 , 0.0 );
gsl_matrix_set ( J , 11 , 10 , 0.0 );
gsl_matrix_set ( J , 11 , 11 , 1.0 );
 }
 atom43 = mpendulum*atom6;
 atom44 = -mpendulum*atom5;
gsl_matrix_set ( J , 6 , 1 , atom43 );
gsl_matrix_set ( J , 8 , 1 , atom44 );
gsl_matrix_set ( J , 9 , 8 , atom6 );
gsl_matrix_set ( J , 10 , 7 , -atom6 );
gsl_matrix_set ( J , 10 , 9 , atom5 );
gsl_matrix_set ( J , 11 , 8 , -atom5 );
return J;
}
